<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-161"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FBase%2FCategory%2FUIButton%2BXHXStyle.m%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/Base/Category/UIButton+XHXStyle.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_e594291297641f362044084ee3bd79c2.html">Base</a></li><li class="navelem"><a class="el" href="dir_7b3ff33937589b3dcfba70141486f64a.html">Category</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">UIButton+XHXStyle.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_u_i_button_09_x_h_x_style_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno"><a class="line" href="category_u_i_button_07_x_h_x_style_08.html#ada77b5760b623e4172ff2ad3adbe1d01">    1</a></span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  UIButton+XHXStyle.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//  XHXKit</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//  Created by wujian on 2019/8/20.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_u_i_button_09_x_h_x_style_8h.html">UIButton+XHXStyle.h</a>&#34;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_u_i_image_09_x_h_x_common_resource_8h.html">UIImage+XHXCommonResource.h</a>&#34;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&nbsp; </div>
<div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="_u_i_button_09_x_h_x_style_8m.html#a8e0197ab54ea94b50f403bc74bf067e1">   11</a></span>&nbsp;<span class="preprocessor">#define KStatusBarHeight [[UIApplication sharedApplication] statusBarFrame].size.height</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="category_u_i_button_07_x_h_x_style_08.html">UIButton (XHXStyle)</a></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&nbsp; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&nbsp;+ (UIButton *)xhx_whiteBackButtonWithTarget:(<span class="keywordtype">id</span>)target action:(<span class="keywordtype">SEL</span>)action {</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&nbsp;    <span class="keywordflow">return</span> [<span class="keyword">self</span> xhx_backButtonWithTarget:target action:action imageName:@&#34;xhx_whiteBack&#34; frame:CGRectMake(16, 25, 60, 34)];</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&nbsp;}</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&nbsp; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&nbsp;+ (UIButton *)xhx_blackBackButtonWithTarget:(<span class="keywordtype">id</span>)target action:(<span class="keywordtype">SEL</span>)action {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&nbsp;    <span class="keywordflow">return</span> [<span class="keyword">self</span> xhx_backButtonWithTarget:target action:action imageName:@&#34;xhx_blackBack&#34; frame:CGRectMake(16, [[UIApplication sharedApplication] statusBarFrame].size.height + 5, 60, 34)];</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&nbsp;}</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&nbsp; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&nbsp;+ (UIButton *)xhx_greenBackButtonWithTarget:(<span class="keywordtype">id</span>)target action:(<span class="keywordtype">SEL</span>)action {</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp;    <span class="keywordflow">return</span> [<span class="keyword">self</span> xhx_backButtonWithTarget:target action:action imageName:@&#34;xhx_greenBack&#34; frame:CGRectMake(16, 25, 60, 34)];</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&nbsp;}</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&nbsp; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp;+ (UIButton *)xhx_backButtonWithTarget:(<span class="keywordtype">id</span>)target action:(<span class="keywordtype">SEL</span>)action imageName:(NSString *)imageName {</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&nbsp;    <span class="keywordflow">return</span> [<span class="keyword">self</span> xhx_backButtonWithTarget:target action:action imageName:imageName frame:CGRectMake(16, 25, 60, 34)];</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&nbsp;}</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&nbsp; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&nbsp;+ (UIButton *)xhx_backButtonWithTarget:(<span class="keywordtype">id</span>)target action:(<span class="keywordtype">SEL</span>)action imageName:(NSString *)imageName frame:(CGRect)frame {</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&nbsp;    UIButton *backButton = [UIButton buttonWithType:UIButtonTypeCustom];</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&nbsp;    <span class="comment">// 12*18 设计要求 无按下状态</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&nbsp;    [backButton setImage:[UIImage xhxCommonImageNamed:imageName] forState:UIControlStateNormal];</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&nbsp;    [backButton addTarget:target action:action forControlEvents:UIControlEventTouchUpInside];</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&nbsp;    [backButton setImageEdgeInsets:UIEdgeInsetsMake(0, 0, 0, 48)];</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&nbsp;    backButton.frame = CGRectMake(16, 25, 60, 34);</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;    <span class="keywordflow">return</span> backButton;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&nbsp;}</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&nbsp; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&nbsp; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&nbsp;<span class="preprocessor">#pragma mark - **************** guohua add method -- 2020.04.17</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&nbsp; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&nbsp;<span class="comment">//设置button的title和image正常显示</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&nbsp;-(void)xhx_setTitleAndImageNormalState</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp;{</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&nbsp;    UIEdgeInsets edgeInsets = UIEdgeInsetsMake(0, 0, 0, 0);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp;    <span class="keyword">self</span>.imageEdgeInsets = edgeInsets;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&nbsp;    <span class="keyword">self</span>.titleEdgeInsets = edgeInsets;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;}</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&nbsp;<span class="comment">//设置button的title和image的左右显示效果(设置之前先确定button的frame)</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&nbsp;-(void)xhx_setTitleAndImageWithTitleLeft:(BOOL)left interval:(CGFloat)interval{</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;    CGFloat imageW  = <span class="keyword">self</span>.imageView.bounds.size.width ;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp;    CGFloat titleW  = <span class="keyword">self</span>.titleLabel.intrinsicContentSize.width;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&nbsp;    CGFloat space = interval*0.5;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&nbsp;    </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&nbsp;    UIEdgeInsets titleEdgeInsets = left ? UIEdgeInsetsMake(0, -imageW*2-space , 0, 0) : UIEdgeInsetsMake(0, 0 , 0, -space);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&nbsp;    UIEdgeInsets imageEdgeInsets = left ? UIEdgeInsetsMake(0, 0 , 0, -titleW*2-space) : UIEdgeInsetsMake(0, -space , 0, 0);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&nbsp;    </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&nbsp;    <span class="keyword">self</span>.imageEdgeInsets = imageEdgeInsets;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&nbsp;    <span class="keyword">self</span>.titleEdgeInsets = titleEdgeInsets;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&nbsp;    </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&nbsp;}</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&nbsp; </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&nbsp;<span class="comment">//设置button的title和image的上下显示效果(设置之前先确定button的frame)</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&nbsp;-(void)xhx_setTitleAndImageWithTitleTop:(BOOL)top interval:(CGFloat)interval{</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&nbsp;    CGFloat imageW      = <span class="keyword">self</span>.imageView.bounds.size.width;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&nbsp;    CGFloat imageH      = <span class="keyword">self</span>.imageView.bounds.size.height;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&nbsp;    CGFloat titleW      = <span class="keyword">self</span>.titleLabel.intrinsicContentSize.width;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&nbsp;    CGFloat titleH      = <span class="keyword">self</span>.titleLabel.intrinsicContentSize.height;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&nbsp;    CGFloat space = interval*0.5;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&nbsp;    <span class="comment">//使图片和文字水平居中显示</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&nbsp;    <span class="keyword">self</span>.contentHorizontalAlignment = UIControlContentHorizontalAlignmentCenter;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&nbsp;    </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&nbsp;    UIEdgeInsets titleEdgeInsets = top ? UIEdgeInsetsMake(-imageH-space, -imageW , 0, 0) : UIEdgeInsetsMake(0, -imageW , -imageH-space, 0);</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&nbsp;    UIEdgeInsets imageEdgeInsets = top ? UIEdgeInsetsMake(0, 0 , -titleH-space, -titleW) : UIEdgeInsetsMake(-titleH-space, 0 , 0, -titleW);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&nbsp;    <span class="keyword">self</span>.imageEdgeInsets = imageEdgeInsets;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&nbsp;    <span class="keyword">self</span>.titleEdgeInsets = titleEdgeInsets;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&nbsp;}</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&nbsp; </div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&nbsp;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="acategory_u_i_button_07_x_h_x_style_08_html"><div class="ttname"><a href="category_u_i_button_07_x_h_x_style_08.html">UIButton(XHXStyle)</a></div><div class="ttdef"><b>Definition:</b> <a href="_u_i_button_09_x_h_x_style_8h_source.html#l00012">UIButton+XHXStyle.h:12</a></div></div>
<div class="ttc" id="a_u_i_image_09_x_h_x_common_resource_8h_html"><div class="ttname"><a href="_u_i_image_09_x_h_x_common_resource_8h.html">UIImage+XHXCommonResource.h</a></div></div>
<div class="ttc" id="a_u_i_button_09_x_h_x_style_8h_html"><div class="ttname"><a href="_u_i_button_09_x_h_x_style_8h.html">UIButton+XHXStyle.h</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
制作者&nbsp;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>


</body></html>